<?php

session_start();
use Box\Spout\Common\Type;
use Box\Spout\Reader\ReaderFactory;
use Box\Spout\Writer\WriterFactory;
include "common.php";

$sslcont=array("ssl"=>array("verify_peer"=>false,"verify_peer_name"=>false,),);
if($_POST["session_name"]!="" && $_POST["session_value"]!=""){
 $session_name=$_POST["session_name"];
 $session_value=$_POST["session_value"];
 $session_name=rawurldecode($session_name);
 $session_value=rawurldecode($session_value);
 $_SESSION[$session_name]=$session_value;
 echo "done ".$session_name."=".$session_value;
}

if($_POST["session_reset"]==1){
 session_start();
 session_unset();
 session_destroy();
 session_write_close();
 setcookie(session_name(),"",0,"/");
 session_regenerate_id(true);
 echo "ok";
}

if($_POST["get_db_list"]==1){
 $arr=explode(",",$_SESSION["sql_db_list"]);
 $s=count($arr).$sql_row_sep."3".$sql_row_sep;
 for($i=0;$i<count($arr);$i++){
  $s=$s.$arr[$i].$sql_col_sep."-1".$sql_col_sep."db".$sql_col_sep.$sql_row_sep;
 }
 echo $s;
}

if($_POST["sql_get"]!=""){
 $sql=$_POST["sql_get"];
 $sql=rawurldecode($sql);
 echo sql_get($sql);
}

if($_POST["sql"]!=""){
 $sql=$_POST["sql"];
 $sql=rawurldecode($sql);
 echo sql_req($sql,"");
}

if($_POST["sql_set"]!=""){
 $sql=$_POST["sql_set"];
 $sql=rawurldecode($sql);
 echo sql_req($sql,"set=1");
}

if($_POST["n_sql"]=="1"){
 $sql=sql_get("select ".$_POST["query"]." from ".$_POST["table"]." limit 1");
 $resu=sql_req($sql,"n_sql=1");
 if($resu!="")sql_req("update ".$_POST["table"]." set ".$_POST["result"]."='".str_replace("'","’",$resu)."'","");
}

if($_POST["save_db_list"]=="1"){
 $s=sql_get("select db__list from conf limit 1");
 if(is_null($s) || $s!=$_SESSION["sql_db_list"]){
  sql_req("update conf set db__list='".$_SESSION["sql_db_list"]."'","");
 }
 echo "ok";
}

if($_POST["rapp_update"]!=""){
 $s=file_get_contents("http://google.com");
 if($s=="")echo "err La connection à Internet ne fonctionne pas";
 else{
  $url="https://santia.org";
  $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
  if($s=="")echo "err Le site Santia.org est inaccessible";
  else{
   $s=sql_get("select Titr from Rapp where Nume=".$_POST["rapp_update"]);
   $s=str_replace(" ","_",$s);
   $url="https://santia.org/rapp/".$s;
   $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
   if($s!=""){
    sql_req("update Rapp set Requ=cast(\"".$s."\" as char character set utf8) where Nume=".$_POST["rapp_update"],"");
    if(s_beg($s,"version="))sql_req("update Rapp set vers=\"".s_read($s,"version")."\" where Nume=".$_POST["rapp_update"],"");
    echo "ok";
   }else echo "err Aucun rapport ayant ce titre sur Santia.org";
  }
 }
}

if($_POST["rapp_all_add_update"]=="1"){
 $s=file_get_contents("http://google.com");
 if($s=="")echo "err La connection à Internet ne fonctionne pas";
 else{
  $url="https://santia.org";
  $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
  if($s=="")echo "err Le site Santia.org est inaccessible";
  else{
   $url="https://santia.org/rapp/rapplist";
   $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
   $s=s_rm_ctrl($s);
   $arr=explode(",",$s);
   $err=0;
   for($i=0;$i<count($arr);$i++){
    $titr=$arr[$i];
    if(sql_get("select count(*) from `Rapp` where `Titr`=\"".str_replace("_"," ",$titr)."\"")=="0")sql_req("insert `Rapp` set `Titr`='".str_replace("_"," ",$titr)."'","");
    $url="https://santia.org/rapp/".$titr;
    $cont=file_get_contents($url);if($cont=="")$cont=file_get_contents($url,false,stream_context_create($sslcont));
    if($cont!=""){
     sql_req("update `Rapp` set `Requ`=cast(\"".$cont."\" as char character set utf8) where `Titr`=\"".str_replace("_"," ",$titr)."\"","");
     if(s_beg($cont,"version="))sql_req("update Rapp set vers=\"".s_read($cont,"version")."\" where `Titr`=\"".str_replace("_"," ",$titr)."\"","");
    }else{$err=1;echo "err Le rapport ".str_replace("_"," ",$titr)." n'a pas été trouvé sur Santia.org";break;}
   }
   if($err==0)echo "ok";
  }
 }
}

if($_POST["last_version"]=="1"){
 $err="";
 sql_req("update `conf` set `lastversdat_`=null","");
 $url="https://santia.org";
 $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
 if($s=="")$err=$err." Le site Santia.org est inaccessible.";
 else{
  $url="https://santia.org/v2/dl_version";
  $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
  $s=trim($s);
  if($s!=""){
   sql_req("update `conf` set `lastversdat_`=\"".$s."\"","");
  }else $err=$err." Le fichier de version manque sur Santia.org.";
 }
 if($err!="")echo "err ".$err;else echo "ok";
}

if($_POST["update_dl"]=="1"){
 $err="";
 $s=file_get_contents("http://google.com");
 if($s=="")$err=$err." La connection à Internet ne fonctionne pas.";
 else{
  $url="https://santia.org";
  $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
  if($s=="")$err=$err." Le site Santia.org est inaccessible.";
  else{
   $url="https://santia.org/v2/dl_zip_list";
   $s=file_get_contents($url);if($s=="")$s=file_get_contents($url,false,stream_context_create($sslcont));
   if($s!=""){
    $arr=explode(" ",$s);
    if(count($arr)==0)$err=$err." La liste des fichiers de mise à jour est vide.";
    else for($i=0;$i<count($arr);$i++){
     $url_f=trim($arr[$i]);
     $loc_f=basename($url_f);
     $loc_f=substr($loc_f,0,strlen($loc_f)-4);
     $loc_f=getcwd()."/".$loc_f;
     if(file_exists($loc_f))rename($loc_f,$loc_f.".old");
     $x=file_get_contents($url_f);if($x==false)$x=file_get_contents($url_f,false,stream_context_create($sslcont));
     file_put_contents($loc_f.".zip",$x);
     $zip=new ZipArchive;
     $res=$zip->open($loc_f.".zip");
     if($res===TRUE){
      $zip->extractTo(pathinfo(realpath($loc_f.".zip"),PATHINFO_DIRNAME));
      $zip->close();
     }else $err=$err." Erreur décompression ".$loc_f.".zip";
     if(!file_exists($loc_f) || filesize($loc_f)==0)$err=$err." Le fichier ".basename($loc_f)." n’a pas été téléchargé.";
    }
   }else $err=$err." La liste des fichiers de mise à jour manque sur Santia.org.";
  }
 }
 if($err!="")echo "err ".$err;else echo "ok";
}

if($_POST["update_sql"]=="1"){
 if(strtoupper(substr(PHP_OS,0,3))!=="WIN"){
  exec("mysql ".$_SESSION['sql_db']." -h ".$_SESSION['sql_host']." -P ".$_SESSION['sql_port']." -u ".$_SESSION['sql_user']." -p".$_SESSION['sql_pwd']." -e 'source ".getcwd()."/dl_update_sql'");
 }else{
  $mysql_dir=sql_get("select @@basedir");
  if(substr($mysql_dir,-1)!=="/")$mysql_dir=$mysql_dir."/";
  $mysql_cmd=$mysql_dir."bin/mysql";
  $content=$mysql_cmd." ".$_SESSION['sql_db']." -h ".$_SESSION['sql_host']." -P ".$_SESSION['sql_port']." -u ".$_SESSION['sql_user']." -p".$_SESSION['sql_pwd']." -e \"source ".getcwd()."/dl_update_sql\"";
  $content=str_replace("/","\\",$content);
  $file=getcwd()."/update_sql.bat";
  file_write($file,$content);
  exec($file);
 }
 $sql_dt=sql_get("select `maj_versdat_` from `conf` limit 1");
 $app_dt=file_read(getcwd()."/dl_version");
 if(trim($sql_dt)!=trim($app_dt))echo "err La mise à jour de la base a échoué (".$sql_dt." / ".$app_dt."). Contactez schaer@santia.org.";
 else echo "ok";
}

if($_POST["rapp_export_convert"]=="1"){
$requ=sql_get("select rapprequ from conf limit 1");
if(s_find($requ,"into outfile '")){
 require_once("spout/Autoloader/autoload.php");
 $requ=sql_get("select rapprequ from conf limit 1");
 $csv=s_aft($requ,"into outfile '");
 $csv=s_bef($csv,"'");
 $xls=str_replace(".csv",".xls",$csv);
 $out=WriterFactory::create(Type::XLSX);
 $out->openToFile(__DIR__."/export/".basename($xls));
 $in=ReaderFactory::create(Type::CSV);
 $in->setFieldDelimiter("\t");
 $in->open($csv);
 foreach($in->getSheetIterator() as $sheet){
  foreach($sheet->getRowIterator() as $row){
   $out->addRow($row);
  }
 }
 $out->close();
}

}

if($_POST["rapp_export_copy"]=="1"){
 if(strtoupper(substr(PHP_OS,0,3))!=="WIN"){
  $requ=sql_get("select rapprequ from conf limit 1");
  if(s_find($requ,"into outfile '")){
   $file=s_aft($requ,"into outfile '");
   $file=s_bef($file,"'");
   $file=str_replace(".csv",".xls",$file);
   $path=getcwd()."/export/";
   exec("cp ".$file." ".$path.basename($file));
  }

 }

 echo "ok";
}

if($_POST["rapp_export_supp"]=="1"){
 $path=getcwd()."/export/";
 if(strtoupper(substr(PHP_OS,0,3))=="WIN")$path=str_replace("/","\\",$path);
 if(strtoupper(substr(PHP_OS,0,3))=="WIN")exec("del ".$path."* /Q");
 else exec("rm ".$path."*");
 echo "ok";
}

if($_GET["print_type"]!="" && $_GET["print_id"]!=""){
 $type=$_GET["print_type"];
 $type=str_replace("'","",$type);
 $id=$_GET["print_id"];
 $id=str_replace("'","",$id);
 $user=$_SESSION["sql_user"];
 $req="select print(\"";
 $req.=$type;
 $req.="\",\"";
 $req.=$id;
 $req.="\",\"";
 $req.=$user;
 $req.="\")";
 echo sql_get($req);
}

?>
